--[[
Spectator.LUA
Created by Megabyte
]]

wplayers = {}

function Triggers.init()
	for p in Players() do
		p._watching=p.index
		p._trigger=false
		p._poly=p.polygon.index
		p._z=p.z
		p._x=p.x
		p._y=p.y
		p.color = p.team
		p._moved=false
		p._cam=Cameras.new()
		if not(p.team=="yellow") then
			wplayers[table.getn(wplayers)+1]=p.index
		end
	end
	Triggers.idle()
end

function Triggers.idle()
	for p in Players() do
		if p.team=="yellow" then
			if Game.ticks==0 then
				p.overlays[3].text = "Spectate.lua uses left trigger to go forward and right to back. Works best with the mouse."
			end
			if Game.ticks>=300 then
				p.overlays[3]:clear()
			end
			if is_monster(p:find_target()) then
				if p:find_target().life>0 then
					p.overlays[1].text=p:find_target().life
				else
					p.overlays[1].text=""
				end
			end
			p.invisibility_duration=100
			
			p:position(0, 0, 20, p.polygon)
			p.life=450
			
			if p.action_flags.action_trigger then
				p._watching=p._watching+1
				if p._watching>table.getn(wplayers) then
					p._watching=0
					p:view_player(p)
				else
					p:view_player(Players[wplayers[p._watching]])
				end
			end
			p.action_flags.action_trigger=false
			
			if p.action_flags.left_trigger or p.internal_velocity.forward>0 then
				p._x = p._x+.2*math.cos(math.pi*p.yaw/180)
				p._y = p._y+.2*math.sin(math.pi*p.yaw/180)
				p._z = p._z+.2*math.sin(math.pi*p.pitch/180)
				change=false
				if Polygons[p._poly]:contains(p._x, p._y, p._z) then
					change = not change
				else
					for q in Polygons[p._poly]:adjacent_polygons() do
						if q:contains(p._x, p._y, p._z) then
							p._poly=q.index
							change = not change
						end
					end
				end
				if not change then
					p._x = p._x-.2*math.cos(math.pi*p.yaw/180)
					p._y = p._y-.2*math.sin(math.pi*p.yaw/180)
					p._z = p._z-.2*math.sin(math.pi*p.pitch/180)
				end
			end
			if p.action_flags.right_trigger or p.internal_velocity.forward<0 then
				p._x = p._x-.2*math.cos(math.pi*p.yaw/180)
				p._y = p._y-.2*math.sin(math.pi*p.yaw/180)
				p._z = p._z-.2*math.sin(math.pi*p.pitch/180)
				change=false
				if Polygons[p._poly]:contains(p._x, p._y, p._z) then
					change = not change
				else
					for q in Polygons[p._poly]:adjacent_polygons() do
						if q:contains(p._x, p._y, p._z) then
							p._poly=q.index
							change = not change
						end
					end
				end
				if not change then
					p._x = p._x+.2*math.cos(math.pi*p.yaw/180)
					p._y = p._y+.2*math.sin(math.pi*p.yaw/180)
					p._z = p._z+.2*math.sin(math.pi*p.pitch/180)
				end
			end
			p:position(p._x, p._y, Polygons[p._poly].ceiling.z+.1, Polygons[p._poly])
			
		end
		for q in Platforms() do
			plat = false
			for m in q.polygon:monsters() do
				if m.type=="player" then
					if not (m.player.team=="yellow") then
						plat = true
					end
				end
			end
			if plat then
				q.player_controllable=true
			else
				q.player_controllable=false
			end
		end
	end
end

function Triggers.postidle()
	for p in Players() do
		if p.team=="yellow" then
			if p._watching==0 then
				p._cam:clear()
				p._cam.path_angles:new(p.yaw, p.pitch, Game.ticks)
				p._cam.path_angles:new(p.yaw, p.pitch, Game.ticks+1)
				p._cam.path_points:new(p._x, p._y, p._z, Polygons[p._poly], Game.ticks)
				p._cam.path_points:new(p._x, p._y, p._z, Polygons[p._poly], Game.ticks+1)
				p._cam:activate(p)
			else
				p._cam:deactivate()
				p:view_player(Players[wplayers[p._watching]])
			end
			p.invisibility_duration=100
			p.weapons.active=false
			p:position(p._x, p._y, Polygons[p._poly].floor.z-20, Polygons[p._poly])
		end
	end
end
